求集合的全部子集問題html
Given a set of distinct integers, S, return all possible subsets.spa
Note:code
For example,
If S = [1,2,3]
, a solution is:htm
[
[3],
[1],
[2],
[1,2,3],
[1,3],
[2,3],
[1,2],
[]
] 本文地址
分析:求集合的全部子集問題。題目要求子集中元素非遞減序排列,所以咱們先要對原來的集合進行排序。原集合中每個元素在子集中有兩種狀態:要麼存在、要麼不存在。這樣構造子集的過程當中每一個元素就有兩種選擇方法:選擇、不選擇,所以能夠構造一顆二叉樹,例如對於例子中給的集合[1,2,3],構造的二叉樹以下(左子樹表示選擇該層處理的元素,右子樹不選擇),最後獲得的葉子節點就是子集:blog
算法1:根據上面的啓發,咱們能夠用dfs來獲得樹的全部葉子節點,代碼以下:排序
1 class Solution { 2 private: 3 vector<vector<int> >res; 4 public: 5 vector<vector<int> > subsets(vector<int> &S) { 6 // IMPORTANT: Please reset any member data you declared, as 7 // the same Solution instance will be reused for each test case. 8 //先排序,而後dfs每一個元素選或者不選,最後葉子節點就是全部解 9 res.clear(); 10 sort(S.begin(), S.end()); 11 vector<int>tmpres; 12 dfs(S, 0, tmpres); 13 return res; 14 } 15 void dfs(vector<int> &S, int iend, vector<int> &tmpres) 16 { 17 if(iend == S.size()) 18 {res.push_back(tmpres); return;} 19 //選擇S[iend] 20 tmpres.push_back(S[iend]); 21 dfs(S, iend+1, tmpres); 22 tmpres.pop_back(); 23 //不選擇S[iend] 24 dfs(S, iend+1, tmpres); 25 } 26 };
算法2:從上面的二叉樹能夠觀察到,當前層的集合 = 上一層的集合 + 上一層的集合加入當前層處理的元素獲得的全部集合(其中樹根是空集),所以能夠從第二層開始(第一層是空集合)迭代地求最後一層的全部集合(即葉子節點),代碼以下:繼承
1 class Solution { 2 public: 3 vector<vector<int> > subsets(vector<int> &S) { 4 // IMPORTANT: Please reset any member data you declared, as 5 // the same Solution instance will be reused for each test case. 6 int len = S.size(); 7 sort(S.begin(), S.end()); 8 vector<vector<int> > res(1);//開始加入一個空集 9 for(int i = 0; i < len; ++i) 10 { 11 int resSize = res.size(); 12 for(int j = 0; j < resSize; j++) 13 { 14 res.push_back(res[j]); 15 res.back().push_back(S[i]); 16 } 17 } 18 return res; 19 } 20 };
算法3:能夠根據二進制的思想,好比對於3個元素的集合,000表示一個元素都不選擇,001表示選擇第一個元素,101表示選擇第一個和第三個元素...。所以若是集合大小爲n,咱們只須要讓一個整數從0逐漸增長到2^n-1, 每一個整數的二進制形式能夠表示一個集合。若是用整數的二進制表示集合,這個算法有個限制,最大能表示集合元素的個數爲64(unsigned long long)。若是使用bitmap,而後模擬二進制的加1操做,則對集合大小就沒有限制。恰好這一題集合的大小不超過64leetcode
1 class Solution { 2 public: 3 vector<vector<int> > subsets(vector<int> &S) { 4 // IMPORTANT: Please reset any member data you declared, as 5 // the same Solution instance will be reused for each test case. 6 int len = S.size(); 7 sort(S.begin(), S.end()); 8 vector<vector<int> > res(1);//開始加入一個空集 9 10 unsigned long long bit = 1, bitmax = (1<<len); 11 vector<int> tmpres; 12 while(bit < bitmax) 13 { 14 tmpres.clear(); 15 unsigned long long curBit = bit; 16 for(int i = 0; i < len; i++)//依次檢測前len個二進制位 17 { 18 if(curBit & 1) 19 tmpres.push_back(S[i]); 20 curBit >>= 1; 21 } 22 res.push_back(tmpres); 23 bit++; 24 } 25 return res; 26 } 27 };
Given a collection of integers that might contain duplicates, S, return all possible subsets.
Note:
For example,
If S = [1,2,2]
, a solution is:
[ [2], [1], [1,2,2], [2,2], [1,2], [] ]
分析:在上一題的基礎上,能夠容許集合中包含重複元素,咱們也把相應的二叉樹畫出類,以集合{1,2,2}舉例
算法1:dfs解法。注意處處理第三個元素2時,由於前面已經處理了一次2,全部第三層中,咱們只在已經添加過2的集合{1,2}、{2}上再添加2,而沒有在集合{1}, {}上添加2(畫叉叉的那麼分支),假設下面還有一個2,那麼咱們只在第四層的包含兩個2的集合{1,2,2}、{2,2}上再添加2,其它都不添加。所以dfs時,若是當前處理的數字前面出現了k次,那麼咱們要處理的集合中必須包含k個該元素。代碼以下:
1 class Solution { 2 private: 3 vector<vector<int> >res; 4 public: 5 vector<vector<int> > subsetsWithDup(vector<int> &S) { 6 // IMPORTANT: Please reset any member data you declared, as 7 // the same Solution instance will be reused for each test case. 8 //先排序,而後dfs每一個元素選或者不選,最後葉子節點就是全部解 9 res.clear(); 10 sort(S.begin(), S.end()); 11 vector<int>tmpres; 12 dfs(S, 0, tmpres); 13 return res; 14 } 15 void dfs(vector<int> &S, int iend, vector<int> &tmpres) 16 { 17 if(iend == S.size()) 18 {res.push_back(tmpres); return;} 19 int firstSame = iend; 20 while(firstSame >=0 && S[firstSame] == S[iend])firstSame--; 21 firstSame++; //firstSame是第一個和S[iend]相同數字的位置 22 int sameNum = iend - firstSame;//和S[iend]相同數字的個數(除本身) 23 if(sameNum == 0 || 24 (tmpres.size() >= sameNum && tmpres[tmpres.size() - sameNum] == S[iend])) 25 { 26 //選擇S[iend] 27 tmpres.push_back(S[iend]); 28 dfs(S, iend+1, tmpres); 29 tmpres.pop_back(); 30 } 31 //不選擇S[iend] 32 dfs(S, iend+1, tmpres); 33 } 34 };
算法2:在上一題算法2的基礎上,若是當前處理的元素沒有出現過,則把前面獲得的全部集合加上該元素;若是出現過,則只把上一輪處理的集合加上該元素。好比處理第二個2時(二叉樹第三層),咱們只把上一輪添加過數字的集合{1,2}、{2}再添加一個2加入結果中,{1}、{}是從上一層直接繼承下來的,因此不做處理。代碼以下:
1 class Solution { 2 private: 3 vector<vector<int> >res; 4 public: 5 vector<vector<int> > subsetsWithDup(vector<int> &S) { 6 // IMPORTANT: Please reset any member data you declared, as 7 // the same Solution instance will be reused for each test case. 8 int len = S.size(); 9 sort(S.begin(), S.end()); 10 vector<vector<int> > res(1);//開始加入一個空集 11 int last = S[0], opResNum = 1;//上一個數字、即將要進行操做的子集數量 12 for(int i = 0; i < len; ++i) 13 { 14 if(S[i] != last) 15 { 16 last = S[i]; 17 opResNum = res.size(); 18 } 19 //若是有重複數字,即將操做的子集的數目和上次相同 20 int resSize = res.size(); 21 for(int j = resSize-1; j >= resSize - opResNum; j--) 22 { 23 res.push_back(res[j]); 24 res.back().push_back(S[i]); 25 } 26 } 27 return res; 28 } 29 };
上一題基於二進制思想的算法3不適合於包含重複元素的集合
【版權聲明】轉載請註明出處:http://www.cnblogs.com/TenosDoIt/p/3451902.html